#!/bin/sh

#file configurazione precedente , file kernel nuovo

file_sorg=$1
file_dest=$2

n_righe_sorg=$(wc -l < $file_sorg)
n_righe_dest=$(wc -l < $file_dest)

echo
echo "Importazione di configurazione da un kernel precedentemente compilato ( l' operazione potrebbe durare qualche minuto ) ... "

if test -f $file_dest.bak
then
	echo "Copia di backup gia' esistente"
else
	cp $file_dest $file_dest.bak
	echo "E' stata salvata una copia di backup del file $file_dest in $file_dest.bak"
fi

i=1;
while test $i -lt $(expr $n_righe_sorg + 1); do

echo $(echo $(head -$i $file_sorg | tail -1)) > $file_temp3
da_trovare=$(cat $file_temp3)

#seleziono solo prima parola chiave di configurazione
trovare=$(cut --delimiter='=' -f 1 $file_temp3)

echo $trovare > $file_temp3

if test $(wc -c < $file_temp3) -gt 2     #maggiore, evita righe vuote
then

trov=$(grep -in "^$trovare" $file_dest)
echo $trov > $file_temp3

#se trovato aggiorno il valore
if test $(wc -c < $file_temp3) -gt 2     #maggiore, evita righe vuote
then

trov=$(cut --delimiter=':' -f 2 $file_temp3)
n_riga_copia=$(cut --delimiter=':' -f 1 $file_temp3)

#rendo univoca la stringa

echo $trov > $file_temp2
sed -e 's| |*|g' $file_temp2 > $file_temp1
trov=$(cat $file_temp1)

echo $da_trovare > $file_temp2
sed -e 's| |*|g' $file_temp2 > $file_temp1
da_trovare=$(cat $file_temp1)

if test $trov != $da_trovare
then

#ripristino univocita
echo $da_trovare > $file_temp2
sed -e 's|*| |g' $file_temp2 > $file_temp1
da_trovare=$(cat $file_temp1)

echo $trov > $file_temp2
sed -e 's|*| |g' $file_temp2 > $file_temp1
trov=$(cat $file_temp1)

#copia prima
rm $file_temp2
z=1;
while test $z -lt $n_riga_copia; do

riga_dest=$(head -$z $file_dest | tail -1)
echo $riga_dest >> $file_temp2

z=$(expr $z + 1)
done

echo $da_trovare >> $file_temp2

echo "Sostituita riga: $z di $n_righe_dest"

#copia dopo
z=$(expr $z + 1)
while test $z -lt $(expr $n_righe_dest + 1); do

riga_dest=$(head -$z $file_dest | tail -1)
echo $riga_dest >> $file_temp2

z=$(expr $z + 1)
done

mv $file_temp2 $file_dest
fi

fi
fi

i=$(expr $i + 1)
done

