#!/bin/sh

#passo  come parametro la directory del kernel sorgente

dir_kernel=$1

#test veste grafica
ps aux > $file_temp3
grep '/usr/X11R6/bin/X' $file_temp3 > $file_temp2
err_X=$(wc -l < $file_temp2)

echo $dir_kernel > $file_temp2
egrep -o $mask_kernel $file_temp2 > $file_temp1
kernel_new=$(cat $file_temp1)

cd $dir_kernel
cd ..

dir_kernel=$PWD"/"
dir_kernel_new=$dir_kernel$kernel_new"/"

ls -l $dir_kernel > $file_temp2
egrep -o $mask_kernel"$" $file_temp2 > $file_temp1

sort -r $file_temp1 | uniq > $file_temp3

n_kernel=$(wc -l < $file_temp3)

if test $n_kernel -ne 0
then


if test $n_kernel -ge 3        #<=
then

echo
echo "Si desidera importare la configurazione tramite uno script che confronta due file di configurazione e copia le impostazioni esistenti nel nuovo dal vecchio s/n ? [n]"
read -n1 bak

case $bak in

s)

echo
echo "Seleziona il kernel dal quale ricavare la configurazione"
i=1;
while test $i -lt $(expr $n_kernel + 1); do

echo "[$i] "$(head -$i $file_temp3 | tail -1)
i=$(expr $i + 1)

done

if test -f /proc/config.gz
then
	echo "[$i] Kernel attualmente caricato"
fi

read -n1 kernel_sorg

if test $kernel_sorg -ne $i
then

	kernel_sorg=$(head -$kernel_sorg $file_temp3 | tail -1)
	dir_kernel_sorg=$dir_kernel$kernel_sorg"/"
	sh $file_import $dir_kernel_sorg".config" $dir_kernel_new".config"

else
	cd $dir_corrent
	zcat /proc/config.gz > .config ;
	sh $file_import $dir_corrent"/.config" $dir_kernel_new".config"
	rm -f $dir_corrent"/.config"
fi

importa=1

;;

*)

importa=2

;;

esac

fi

fi


#vai a capo
echo

if test $importa -eq 2
then

echo "Scegliere la modalit di compilazione: [2]"

else

echo "Scegliere la modalit di compilazione, poich si  importato un kernel precedente  consigliato la modalit oldconfig: [4]"

fi

echo "[1] Modalit domanda e risposta ( config )"
echo "[2] Modalit finestre e men testuali ( menuconfig )"

if test $err_X -ne 0
then echo "[3] Modalit grafica di compilazione ( xconfig )"
fi

echo "[4] Carica configurazione da un file di configurazione gia' esistente ( oldconfig )"


read -n1 risp

#vai a capo
echo

case $risp in

1) mode="config";;
2) mode="menuconfig";;
3) if test $err_X -ne 0
   then
	mode="xconfig"
   fi
   ;;
4) mode="oldconfig";;

"")if test $importa -eq 2
then

mode="menuconfig"

else

mode="oldconfig"

fi

;;

*) echo "Risposta interpretabile, il programma verr terminato";exit;;

esac

echo "Dove si vuole trasferire i file di configurazione del nuovo kernel compilato [ /boot/ ]? "
read dir_boot

echo $dir_boot > $file_temp2
n_char=$(wc -c < $file_temp2)

if test $n_char -ne 1
then

#aggiungo lo slash se necessario
dir_boot=$(awk -f $file_addslash < $file_temp2)

else

#default
dir_boot="/boot/"

fi

#ritorno nella directory corrente per far pulizia dei file
#cd $dir_corrent


#echo $dir_kernel > $file_temp1
#dir_kernel=$(awk -f $file_addslash < $file_temp1)

sh $file_run_install_kernel $dir_kernel_new $mode $dir_boot $importa

